﻿------------------------------------------------------------------------------------------
--Monk Chi--------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")
local CP = SN:GetModule("classResources")

local unpack = unpack
local collectgarbage = collectgarbage
local SPELL_POWER_CHI = SPELL_POWER_CHI
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax

function CP:SetupChi()
	if SN.playerClass ~= "MONK" then return end
	local frame = F.classpower
	local color = M.classResources.MONK
	local maxChi = SN['classMaxResourceBar']["MONK"]

	frame.chi = CP:PowerBubbles(maxChi)
	for i = 1, maxChi do
		frame.chi[i]:SetStatusBarColor(unpack(color[i]))
	end

	frame.chi:SetScript("OnEvent", function(self, event, ...)

		if event == "UNIT_POWER" or event == "UNIT_DISPLAYPOWER" then
			local light = UnitPower("player", SPELL_POWER_CHI)
			local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

			for i = 1, numPoints do
				if i <= light then
					self[i]:SetAlpha(1)
				else
					self[i]:SetAlpha(0.1)
				end
				self[i]:SetSize((SN.data.profile.classResources.width - (numPoints + 1) * 3) / numPoints, SN.data.profile.classResources.height - 6)
				self[i]:Show()
				if numPoints < self.maxChi then
					self[self.maxChi]:Hide()
				end
			end
		end
		if event == "PLAYER_ENTERING_WORLD" then
			local light = UnitPower("player", SPELL_POWER_CHI)
			local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

			for i = 1, numPoints do
				if i <= light then
					self[i]:SetAlpha(1)
				else
					self[i]:SetAlpha(0.1)
				end
				self[i]:SetSize((SN.data.profile.classResources.width - (numPoints + 1) * 3) / numPoints, SN.data.profile.classResources.height - 6)
				self[i]:Show()
			end
		end
	end)

	local light = UnitPower("player", SPELL_POWER_CHI)
	local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

	for i = 1, numPoints do
		if i <= light then
			frame.chi[i]:SetAlpha(1)
		else
			frame.chi[i]:SetAlpha(0.1)
		end
		frame.chi[i]:SetSize((SN.data.profile.classResources.width - (numPoints + 1) * 3) / numPoints, SN.data.profile.classResources.height - 6)
		frame.chi[i]:Show()
		if numPoints < frame.chi.maxChi then
			frame.chi[frame.chi.maxChi]:Hide()
		end
	end
end

function SN:ChiEnable()
	local frame = F.classpower
	frame.chi:Show()
	frame.chi:RegisterEvent("PLAYER_ENTERING_WORLD")
	frame.chi:RegisterEvent("UNIT_POWER")
	frame.chi:RegisterEvent("UNIT_DISPLAYPOWER")
	frame.chi:RegisterEvent("PLAYER_LEVEL_UP")
	collectgarbage("collect")
end

function SN:ChiDisable()
	local frame = F.classpower
	frame.chi:UnregisterAllEvents()
	frame.chi:Hide()
	collectgarbage("collect")
end